﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
#AdditionalJar: sqlite-jdbc-3.8.10.2.jar
#AdditionalJar: jfxtras-labs-2.2-r5.jar
Sub Process_Globals
	Private fx As JFX
	Private frmObject As Form
	Private lblSignHeader  As Label
	Private TabPane1 As TabPane

	Private lblProvHeader As Label
	Private tvProv As TableView
	
	Private lblCondition As Label
	Private lblCons As Label
	Private lblConsDate As Label
	Private lblDateMade As Label
	Private lblName As Label
	Private lblselectObject As Label
	Private lblAccn As Label
	Private lblMaterials As Label
	
	Private txtAccnYear,txtAccnCode,txtAccnNo,txtCons,txtConsDate, txtStorage, txtObjectType, txtCondition As TextField
	Private txtDateMade,txtName, txtExport, txtMaterials As TextField
	Private txtWidth,txtDepth,txtHeight,txtSet,txtYearStart,txtYearEnd As TextField
	Private txtAccnBy,txtAccnDate, txtLoan As TextField
	Private txtDescription, txtConditionNote, txtHistory As TextArea
	Private btnAdd,btnEdit,btnDelete,btnDeleteAll,btnExport As Button
	Private btnSave1, btnSave2, btnExit, btnSetup, btnImport, btnClear, btnClearSearch, btnSelectImage As Button
	Private cboSearch As ComboBox
	
	Dim DBFileName As String				: DBFileName = "SCM.db3"
	Dim DBFileDir As String					:  DBFileDir = "../Data"
	
		
	'variables for criteria
	Dim strQuery,ObjAccn,objAccnBy,ObjAccnYear,ObjAccnCode, objAccnDate,ObjAccnNo,ObjCond,ObjCondNote,objCons,objConsDate,ObjDate,ObjDesc, objYearStart, objYearEnd  As String
	Dim objDepth, objHeight, objExport, ObjHist, objLoan, objName, ObjSet, objWidth, objStorage, objType, objMaterials, objFolder, Primary, Second   As String
	Dim txtCount,txtProvCount,txtProvCount1 As TextField
	'variables for significance statement			
    Dim His, Aes, Sci, Soc, Units As String: Dim Cons As String:His=0:Aes=0:Sci=0:Soc=0
	Dim Action,ObjID,PCount,Cval,ProvID As Int:ObjID=0:PCount=0:Cval=0:ProvID= 0
	Dim strSearch As String:strSearch="ALL"
	Dim SQL1 As SQL
	'form views
	Private txtName, txtExport,txtSearch As TextField
	Private txtCons, txtConsDate ,txtDateMade As TextField
	Private txtPrimaryClass, txtSecondClass As TextField
	Public tblObjEdit As TableView
	Private lblCondition, lblCons,lblConsDate As Label
	Private lblDateMade,lblSelectCriteria As Label
	Private lblselectObject,lblValues, lblUnits As Label
	Private Pane1,Pane2 As Pane
	'Radio buttons and panels
	'historic
	Dim paneHist As Pane:Private lblHistoric As Label:Private txtHist As TextField
	Private Hist1,Hist2,Hist3,Hist4,Hist5 As RadioButton
	'Aesthetic
	Dim paneAes As Pane:Private lblAesthetic As Label:Private txtAes As TextField
	Private Aes1,Aes2,Aes3, Aes4, Aes5 As RadioButton
	'Scientific
	Dim paneSci As Pane:Private lblScientific As Label:Private txtSci As TextField
	Private Sci1,Sci2, Sci3, Sci4,Sci5 As RadioButton
	'Social
	Dim paneSoc As Pane:Private lblSocial As Label:Private txtSoc As TextField
	Private Soc1,Soc2,Soc3,Soc4,Soc5 As RadioButton
	Dim Action As Int
	'
	Private lblCultvalue As Label
	Public txtCultvalue,txtCultvalue1 As TextField
	Private Toast As ToastMessageShow
	Private lblProvCount As Label
	Private btnProvAdd, btnProvDelete As Button 
	Private btnCreate As Button
	Private txtSig As TextArea
	Private lblEmail As Label
	Private lblEvalTeam As Label
	Private lblOrganisation As Label
	Public txtEmail As TextField
	Public txtEvalTeam As TextField
	Public txtOrganisation As TextField
	Private ImageView1 As ImageView
	Private lblImageFolder As Label
	Private lblImageHeader As Label
	Private txtImageFolder As TextField
End Sub

Public Sub ShowObject 
	
	If  frmObject.IsInitialized = False Then
		frmObject.Initialize("frmObject", 1200, 650)
		frmObject.SetFormStyle("DECORATED")
		frmObject.RootPane.LoadLayout("Objects")
		frmObject.Stylesheets.Add(File.GetUri(File.DirAssets, "TabPane.css"))
		TabPane1.StyleClasses.Add("tab-pane")
		TabPane1.LoadLayout("ObjDetailsTab", "Details")
		TabPane1.LoadLayout("ObjProvTab", "History/Provenance")
		TabPane1.LoadLayout("ObjSignTab", "Significance")
		TabPane1.LoadLayout("ObjImageTab", "Image")	
		
		
		Toast.Initialize("Toast")
		Toast.ToastIconSize32x32
		Toast.ToastDuration = 6 'Toast.TOAST_LONG_DELAY
		Toast.ToastTextLocation = Toast.TEXT_CENTER
		Toast.ToastLocation= Toast.TOAST_CENTER_RIGHT
		Toast.ToastMessageColor = fx.Colors.Green
	
	'open database and show Objects in Tableview
	SQL1.InitializeSQLite(File.DirApp, "SCM.db3",False)
	Log(File.DirApp)
	
	'load object tableview
	strQuery = "SELECT _id[ID],  Accession[Accn No.], Name[Object Name] FROM Objects Order BY Name;"
	DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,tblObjEdit)
	tblObjEdit.SetColumnVisible(0,False)
	tblObjEdit.SetColumnWidth(1,80)
	tblObjEdit.SetColumnWidth(2,200)
	
	'load search
	cboSearch.Value="ALL"
	cboSearch.Items.AddAll(Array As String("ALL", "Accession", "Name", "AccBy", "AccDate", "CondNote", "Condition", "Conservator", "ConsDate","DateMade", "Description", "Export", "History", "Loan", "ObjectSet", "ObjectType", "PrimaryClass", "SecondClass", "Storage"))


	'Load units
	strQuery="Select Units from SetUp Where _id=1"
	Dim m As Map
	m = DBUtils.ExecuteMap(SQL1, strQuery, Null)
	lblUnits.Text=m.Get("units")
	Units=lblUnits.Text

	frmObject.Show
	End If
End Sub

Sub tblObjEdit_SelectedRowChanged(Index As Int, Row() As Object)
	If Index = -1 Then Return
	ObjID=Row(0)
	strQuery="SELECT * FROM Objects where _id ="& ObjID &";"
	btnSave1.Visible=True
	btnSave2.visible=True
	btnClear.Visible=True
	btnDelete.Visible=True
	btnEdit.Visible=True
	LoadObjectData
	lblProvHeader.Text=" Provenance for " & objName
	lblImageHeader.text=" Image of " &objName
	btnProvAdd.Text="Add Provenance for " & objName
	btnCreate.Text="Create Significance Statement for " & objName
	lblSignHeader.Text=" Significance for " & objName
	btnEdit.Text="Edit Record: "& objName
	btnDelete.Text="Delete Record: "& objName
	
End Sub	

Sub LoadObjectData
	SQL1.InitializeSQLite(File.DirApp, "SCM.db3", True)	
	Dim m As Map
	
	m = DBUtils.ExecuteMap(SQL1, strQuery, Null)
	If m.IsInitialized = False Then
		txtName.Text = "Please  select a record or add new....."

	Else
		'Display data and store for Significance
		txtName.Text = m.Get("name")              		:objName=txtName.Text
		txtAccnBy.Text=m.Get("accby")					:objAccnBy=txtAccnBy.Text
		txtAccnDate.Text=m.Get("accdate")				:objAccnDate=txtAccnDate.Text
		txtAccnYear.Text=m.Get("accyear")		    	:ObjAccnYear=txtAccnYear.Text
		txtAccnCode.Text=m.Get("acctext") 				:ObjAccnCode=txtAccnCode.Text
		txtAccnNo.Text=m.Get("accnum")         			:ObjAccnNo=txtAccnNo.Text
		txtSet.Text=m.Get("objectset")					:ObjSet=txtSet.Text	
		lblAccn.Text=ObjAccnYear &"."& ObjAccnCode &"."& ObjAccnNo         :ObjAccn=lblAccn.Text	
		txtMaterials.Text=m.Get("materials")			:objMaterials=txtMaterials.Text	           
		txtCondition.Text=m.Get("condition")          	:ObjCond=txtCondition.Text
		txtDescription.Text=m.Get("description")        :ObjDesc=txtDescription.Text
		txtHistory.Text=m.Get("history")             	:ObjHist=txtHistory.Text
		txtConditionNote.Text=m.Get("condnote")         :ObjCondNote=txtConditionNote.Text
		txtWidth.Text=m.Get("width")        	 		:objWidth=txtWidth.Text
		txtHeight.Text=m.Get("height")        			:objHeight=txtHeight.Text
		txtDepth.Text=m.Get("depth")         			:objDepth=txtDepth.Text
		txtExport.Text=m.Get("export")					:objExport=txtExport.Text
		txtStorage.text=m.Get("storage")				:objStorage=txtStorage.Text
		txtObjectType.Text=m.Get("objecttype")		    :objType=txtObjectType.Text
		txtDateMade.Text=m.get("datemade")				:ObjDate=txtDateMade.Text
		txtYearStart.Text=m.Get("yearstart")			:objYearStart=txtYearStart.Text
		txtYearEnd.Text=m.Get("yearend")				:objYearEnd=txtYearEnd.Text
		txtConsDate.Text=m.Get("consdate")              :objConsDate=txtConsDate.Text
		txtCons.Text=m.Get("conservator")               :objCons=txtCons.Text
		txtLoan.Text=m.Get("loan")						:objLoan=txtLoan.Text
		txtImageFolder.Text=m.Get("imagefolder")		:objFolder=txtImageFolder.Text						
		
		'load the Primary and Secondary Classification data..
		txtPrimaryClass.Text=(m.Get("primaryclass"))	:Primary=txtPrimaryClass.Text
		txtSecondClass.Text=(m.Get("secondclass"))		:Second=txtSecondClass.Text
		txtHist.Text=m.Get("historic")				    :His=txtHist.Text	
		txtAes.Text=m.Get("aesthetic")					:Aes=txtAes.Text
		txtSci.Text=m.Get("scientific")					:Sci=txtSci.Text
		txtSoc.text=m.Get("social")						:Soc=txtSoc.Text
		Utils.UpdateRBOs(1)
		txtCultvalue.Text=m.Get("culturalvalue")		:Cval=txtCultvalue.text
		txtCultvalue1.Text=m.Get("culturalvalue")
		
		'update provenance count
		If m.Get("provcount")=Null Then
		txtCount.Text=0
		txtProvCount.Text=0
		Else
		txtCount.Text=m.Get("provcount")
		txtProvCount.text=m.Get("provcount")			:PCount=txtProvCount.Text
		End If
		
		'update buttons	and headers				
		lblProvHeader.Text=" Provenance for " & objName
		lblImageHeader.text=" Image of " &objName
		btnProvAdd.Text="Add Provenance for " & objName
		btnEdit.Text="Edit Record: " & txtName.text
		btnDelete.Text= "Delete Record: " & txtName.text
		btnCreate.Text="Create Significance Statement for " & objName
		lblSignHeader.Text=" Significance for " & objName
		
	'show object image
	'get image folder'Return fileSelected
	Log(txtImageFolder.Text)
	ImageView1.Visible=False
	If txtImageFolder.Text<>"null"  And txtImageFolder.Text<>"" Then
	ImageView1.SetImage(fx.LoadImage(File.getfileparent(txtImageFolder.Text),File.getname(txtImageFolder.Text)))
	ImageView1.Visible=True
End If		
	
'get significance statement		
		If m.Get("sig") <> Null Then
		txtSig.Text=m.Get("sig")
		Sig=txtSig.Text						
		End If

'update the crieria radio buttons
''++++reset the radio buttons to stored value
			If Action<>2 Then
				'dont update from import
			Dim frm As String
			frm= 1
			Utils.UpdateRBOs(frm)
			'store cultural value
			
			End If
	End If
LoadProvData
LoadSigData

End Sub

Sub btnAdd_Action
	Dim btn As Button
	btn=Sender
	Action=btn.tag
	'edit record

			If ObjID>0 Or Action=2 Then ObjectAdd.EditAddObject	
End Sub

Sub btnDelete_Action
	'record must be selected
	If ObjID>0 Then
		Dim res As Int = fx.Msgbox2(Null, "Confirm Deletion of " & objName,"Confirm Deletion","Yes", "", "No", fx.MSGBOX_WARNING)
			If res = fx.DialogResponse.POSITIVE Then
			Dim mp As Map
			mp.Initialize
			mp.Put("_id",ObjID)
			DBUtils.DeleteRecord(SQL1,"Objects", mp)
			mp.Initialize
			mp.Put("objectid", ObjID)
			DBUtils.DeleteRecord(SQL1,"prov",mp)
			Toast.ToastShow("Deleted Record.. " & objName)
			btnClearsearch_action
			ObjID=0
			txtName.Text = "Please  select a record or add new....."
			End If
	End If
End Sub

Sub btnDeleteAll_Action
	Dim res As Int = fx.Msgbox2(Null, "Confirm Deletion of ALL RECORDS","Confirm Deletion","Yes", "", "No", fx.MSGBOX_WARNING)
	If res = fx.DialogResponse.POSITIVE Then
	strQuery="Delete From Objects"
	SQL1.ExecNonQuery(strQuery)
	strQuery="Delete From prov"
	SQL1.ExecNonQuery(strQuery)
	Toast.ToastShow("ALL Records Deleted !!")
	SynchroniseObject
	End If

End Sub 

Sub btnSearch_Action
	If txtSearch.Text="" Then Return
	
	If cboSearch.value=Null Then Return 'user has not selected record
	'Log(cboSearch.Value)
	
	If cboSearch.value<>"ALL" Then
	strQuery = "SELECT _id[ID],  Accession[Accn No.], " & cboSearch.value &" FROM Objects Where " & cboSearch.Value & " Like '%" & txtSearch.Text &"%' Order BY Name;"
	
	'load object tableview
	DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,tblObjEdit)
	tblObjEdit.SetColumnVisible(0,False)
	tblObjEdit.SetColumnWidth(1,80)
	tblObjEdit.SetColumnWidth(2,200)
	Else
	'load object tableview from user search term
	Dim strsearchstring As String
	Dim strItem As String
	Dim k, l As Int
	Dim lst As List
    
	lst.initialize
	lst.AddAll(cboSearch.Items)
	For k=1 To lst.Size-1 'dont add first item
	strItem=lst.Get(k)
	strsearchstring= strsearchstring & " " & strItem & " like '%" &txtSearch.Text &"%' OR "
	Next
	l=strsearchstring.length
	strsearchstring =Utils.Mid(strsearchstring,1,(l-3))
	'Log (strsearchstring)
	'load object tableview
	strQuery = "SELECT * FROM Objects Where " & strsearchstring & "  Order BY Name;"
	DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,tblObjEdit)
	tblObjEdit.SetColumnVisible(0,False)
	tblObjEdit.SetColumnWidth(1,80)
	tblObjEdit.SetColumnWidth(2,200)
	For k=3 To lst.Size-1
	tblObjEdit.SetColumnVisible(k,False)
	Next
	End If
	Dim jo As JavaObject = tblObjEdit
	jo.RunMethod("setFixedCellSize",Array(24.0d))  ' 24 is the default height for cells
	

	End Sub

Sub TabPane1_TabChanged (SelectedTab As TabPage)
'	Log($"Selected tab = ${SelectedTab.Text}"$)
	'End If
End Sub

Sub tvProv_SelectedRowChanged(Index As Int, Row() As Object)
	If Index = -1 Then Return
	Dim m As Map
	ProvID=Row(0)

	strQuery="SELECT * FROM Prov where _id ="& ProvID &" ORDER BY LinkType;"	
			m = DBUtils.ExecuteMap(SQL1, strQuery, Null)	
			btnProvDelete.Text="Delete link to " & m.Get("linkname")
End Sub

Sub LoadProvData
	'load Provenance tableview
		
			btnProvDelete.Text = "Please Select a Provenance.."
			strQuery="SELECT _id, OBJECTID,LinkType as'Link Type',Link,LinkName as 'Linked Entity', LinkDate as 'Link Date',ProvCount FROM Prov Where ObjectID=" & ObjID &" ORDER BY LinkType"
			DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,tvProv)
			tvProv.SetColumnVisible(0,False)
			tvProv.SetColumnVisible(1,False)
			tvProv.SetColumnWidth(2,100)
			tvProv.SetColumnWidth(3,150)
			tvProv.SetColumnWidth(4,320)
			tvProv.SetColumnWidth(5,120)
			tvProv.SetColumnVisible(6,False)
			Utils.GetProvCount
			
End Sub

Sub LoadSigData
	strQuery="SELECT * FROM Setup"
	Dim m As Map
	m.Initialize
	m = DBUtils.ExecuteMap(SQL1, strQuery, Null)
	'LogDebug(m)
	
		'Display data and store for Significance
		txtOrganisation.Text = m.Get("organisation")                                      
		txtEmail.Text=m.get("email")				
		txtEvalTeam.Text=m.Get("evalteam") 
End Sub

Sub btnSelectImage_Action
		
	Dim fc As FileChooser                 ' Use filechooser from jFX library
	Dim fileSelected As String            ' File selected. If selected full path is returned else ""
	fc.Initialize                         ' Init! Do not forget
	fc.InitialDirectory = File.DirApp     ' Set starting folder
	fc.Title = "Select a File"
	fc.SetExtensionFilter("Image Files..",Array As String("*.jpg","*.png"))
  
   fileSelected = fc.ShowOpen(frmObject) ' Show the dialog and select  
   
   Log(fileSelected)
  
   'Return fileSelected
If fileSelected<>"" Then
   txtImageFolder.Text=fileSelected
	ImageView1.SetImage(fx.LoadImage(File.getfileparent(fileSelected),File.getname(fileSelected)))
	ImageView1.Visible=True
End If			

	
   
End Sub

Sub SynchroniseObject

strQuery = "SELECT _id[ID],  Accession[Accn No.], Name[Object Name] FROM Objects Order BY Name;"
	DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,tblObjEdit)
	tblObjEdit.SetColumnVisible(0,False)
	tblObjEdit.SetColumnWidth(1,80)
	tblObjEdit.SetColumnWidth(2,200)
					
					Utils.UpdateRBOs(1)
					
					txtProvCount.Text=PCount
					txtCount.Text=PCount
					txtCultvalue.Text=Cval
					txtCultvalue1.Text=Cval
					lblAccn.Text=ObjAccn
					txtAccnBy.Text=objAccnBy
					txtAccnCode.Text=ObjAccnCode
					txtAccnDate.Text=objAccnDate
					txtAccnNo.Text=ObjAccnNo
					txtAccnBy.Text=objAccnBy
					txtAccnYear.Text=ObjAccnYear
					txtSet.Text=ObjSet
					txtCondition.Text=ObjCond
					txtMaterials.Text=objMaterials
					txtStorage.Text=objStorage
					txtObjectType.Text=objType
					txtConditionNote.Text=ObjCondNote
					txtConsDate.Text=objConsDate         
					txtCons.Text=objCons
					txtDateMade.Text=ObjDate
					txtImageFolder.Text=objFolder
					txtYearStart.Text=objYearStart
					txtYearEnd.Text=objYearEnd
					txtDescription.Text=ObjDesc
					txtHeight.Text=objHeight
					txtHistory.Text=ObjHist
					txtExport.Text=objExport
					txtName.Text=objName
					txtWidth.Text=objWidth
					txtDepth.Text=objDepth
					txtLoan.Text=objLoan
					                            
					'load the Primary and Secondary Classification data..
					txtPrimaryClass.Text=Primary
					txtSecondClass.Text=Second
					
					'load the criteria settings              
					txtHist.Text=His			    
					txtAes.Text	=Aes	
					txtSoc.text=Soc
					txtSci.text=Sci
					txtCultvalue.Text=Cval
					txtCultvalue1.Text=Cval
					Utils.UpdateRBOs(1)
					'reset the provenance tab and get reset prov count
					LoadProvData
					
	
	
	lblProvHeader.Text=" Provenance for " & objName
	lblImageHeader.text=" Image of " & objName
	btnProvAdd.Text="Add Provenance for " & objName
	btnCreate.Text="Create Significance Statement for " & objName
	lblSignHeader.Text=" Significance for " & objName
	btnEdit.Text="Edit Record: "& objName
	btnDelete.Text="Delete Record: "& objName
End Sub

Sub btnProvAdd_MouseClicked (EventData As MouseEvent)
	Dim mp As Map
	Dim btn As Button
btn=Sender
Action=btn.tag
Select  btn.Tag
	
	Case  "1"
		'add new prov
	ProvPicker.ProvPickerLoad
	
	
	Case "2"
		'deleteProv
		mp.Initialize	
		mp.Put("_id",ProvID)
		
			DBUtils.DeleteRecord(SQL1,"Prov",mp)
			'recalculate ProvCount
				Utils.GetProvCount
			LoadProvData
			Toast.ToastShow("Deleted Provenance Record...")
End Select
End Sub

Sub btnCreate_Action
	txtSig.Text=Utils.GetSig
	Sig=txtSig.Text
	
End Sub

Sub btnSave1_Action
	If txtName.Text = "Please  select a record or add new....." Then Return
	If lblAccn.Text=".." Then
	 fx.Msgbox2(Null, "An Accession Number is required for " & objName,"Please Update","OK", "", "", fx.MSGBOX_WARNING)
	 Return	
	End If
		
		Utils.GetProvCount
		Dim mp As Map
		mp.Initialize
		mp.Clear
		Dim wf As Map
		wf.Initialize
				wf.Put("_id",ObjID)
				mp.Put("loan",txtLoan.Text)
				mp.Put("accby", txtAccnBy.Text)
				mp.Put("name",txtName.Text)
				mp.Put("accession",lblAccn.Text)
				mp.Put("accyear", txtAccnYear.Text)
				mp.Put("acctext", txtAccnCode.Text)
				mp.Put("accnum", txtAccnNo.Text)
				mp.Put("objectset", txtSet.Text)
				mp.Put("accdate", txtAccnDate.Text)
				mp.Put("objecttype", txtObjectType.Text)
				mp.Put("export", txtExport.Text)
				mp.Put("description",txtDescription.Text)
				mp.Put("materials",txtMaterials.Text)
				mp.Put("primaryclass",txtPrimaryClass.Text)
				mp.Put("secondclass",txtSecondClass.Text)
				mp.Put("datemade",txtDateMade.Text)
				mp.Put("yearstart",txtYearStart.Text)
				mp.Put("yearend",txtYearEnd.Text)
				mp.Put("condition",txtCondition.Text)
				mp.Put("condnote",txtConditionNote.Text)
				mp.Put("consdate",txtConsDate.Text)
				mp.Put("storage",txtStorage.Text)
				mp.Put("conservator",txtCons.Text)
				mp.Put("historic",His)
				mp.Put("aesthetic",Aes)
				mp.Put("scientific",Sci)
				mp.Put("social",Soc)
				mp.Put("history",txtHistory.Text)
				mp.Put("width",txtWidth.Text)
				mp.Put("height",txtHeight.Text)
				mp.Put("depth",txtDepth.Text)
				mp.Put("export",txtExport.Text)
				mp.Put("sig",txtSig.Text)
				mp.Put("culturalvalue",Cval)
				mp.Put("provcount",PCount)
				mp.Put("imagefolder",txtImageFolder.text)
		
		DBUtils.UpdateRecord2(SQL1, "Objects", mp,wf)
		Toast.ToastMessageColor = fx.Colors.Yellow
		Toast.ToastShow("Record has been updated.")

End Sub

Sub btnExit_Action
	ExitApplication
End Sub

Sub btnSetUp_Action
	SetupForm.LoadSetup
End Sub

Sub btnClear_action
	txtSig.Text=""
	Sig=""
End Sub

Sub btnClearsearch_action
	txtSearch.Text=""
	cboSearch.Value="ALL"
	'refresh table
	'load object tableview
	strQuery = "SELECT _id[ID],  Accession[Accn No.], Name[Object Name] FROM Objects Order BY Name;"	
	DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,tblObjEdit)
	tblObjEdit.SetColumnvisible(0,False)
	tblObjEdit.SetColumnWidth(1,80)
	tblObjEdit.SetColumnWidth(2,200)
End Sub

